﻿//
//Shell Launcher Utility
//Annabooks, LLC.
//Copyright (c) 2016 Annabooks, LLC. All Rights Reserved
//
//
//The sample application demonstrates some basic Shell Launcher WMI APIs in C#
//
//
//Date: 12/2/2016 - Comments generated
//
//Source code provided as is without any warranty
//

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Management;

namespace SLUtility
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            SLStatus();
        }

        public void SLStatus()
        {
            ManagementScope scope = new ManagementScope(@"root\standardcimv2\embedded");
            ManagementClass WESL = new ManagementClass(scope.Path.Path, "WESL_UserSetting", null);

            ManagementBaseObject SLStatus = WESL.InvokeMethod("IsEnabled", null, null);

            String bSLStatus = SLStatus["Enabled"].ToString();
            if (bSLStatus == "True")
            {
                txtSLStatus.Text = "Enabled";

                ManagementBaseObject OutSideParam = WESL.InvokeMethod("GetDefaultShell", null, null);

                txtDefaultShell.Text = OutSideParam["Shell"].ToString();
                String sDefaultAction = OutSideParam["DefaultAction"].ToString();

                switch (sDefaultAction)
                {
                    case "0":
                        rbRestartApp.Checked = true;
                        break;
                    case "1":
                        rbRestartDevice.Checked = true;
                        break;
                    case "2":
                        rbShutdownDevice.Checked = true;
                        break;
                }

            }
            else
            {
                txtSLStatus.Text = "Disabled";
                txtDefaultShell.Text = "Explorer Shell";
                rbRestartApp.Checked = false;
                rbRestartDevice.Checked = false;
                rbShutdownDevice.Checked = false;
            }

        }


        private void btnEnableSL_Click_1(object sender, EventArgs e)
        {
            ManagementScope scope = new ManagementScope(@"root\standardcimv2\embedded");
            ManagementClass WESL = new ManagementClass(scope.Path.Path, "WESL_UserSetting", null);
            ManagementBaseObject Enabledparams = WESL.GetMethodParameters("SetEnabled");

            Enabledparams["Enabled"] = true;
            WESL.InvokeMethod("SetEnabled", Enabledparams, null);
            sslStatus.Text = "Changed to enabled, reboot required";
        }

        private void btnDisableSL_Click_1(object sender, EventArgs e)
        {
            ManagementScope scope = new ManagementScope(@"root\standardcimv2\embedded");
            ManagementClass WESL = new ManagementClass(scope.Path.Path, "WESL_UserSetting", null);
            ManagementBaseObject Enabledparams = WESL.GetMethodParameters("SetEnabled");

            Enabledparams["Enabled"] = false;
            WESL.InvokeMethod("SetEnabled", Enabledparams, null);
            sslStatus.Text = "Changed to disable, reboot required";
        }

        private void btnOpenFile_Click_1(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "exe files (*.exe)|*.exe|All files (*.*)|*.*";
            openFileDialog1.FilterIndex = 1;
            openFileDialog1.FileName = "";
            openFileDialog1.Title = "Open an Executable to be the shell";
            DialogResult userClickedOk = openFileDialog1.ShowDialog();
            if (userClickedOk == DialogResult.OK)
            {
                txtDefaultShell.Text = openFileDialog1.FileName;
                sslStatus.Text = "Shell Launcher must be enabled to launch default shell";
            }
        }

        private void btnSetDefaultShell_Click_1(object sender, EventArgs e)
        {
            ManagementScope scope = new ManagementScope(@"root\standardcimv2\embedded");
            ManagementClass WESL = new ManagementClass(scope.Path.Path, "WESL_UserSetting", null);
            ManagementBaseObject SetDSParams = WESL.GetMethodParameters("SetDefaultShell");

            SetDSParams["Shell"] = txtDefaultShell.Text;
            SetDSParams["DefaultAction"] = 0; //The default parameter is restart app

            //Change the default action if the other items are checked.

            if (rbRestartDevice.Checked == true)
            {
                SetDSParams["DefaultAction"] = 1;
            }
            if (rbShutdownDevice.Checked == true)
            {
                SetDSParams["DefaultAction"] = 2;
            }

            WESL.InvokeMethod("SetDefaultShell", SetDSParams, null);
            sslStatus.Text = "Default Shell Updated";
        }
    }
}
